"use strict";
var path = require('path');
var env = process.env.env_config;
exports.interpolateHTMLAssets = function (content, domain) {
    var reIgnorePath = /^(?:(https?:)?\/\/)|(?:data:)/;
    var reImport = /(?:<(?:link|script|img)[^>]+(?:src|href)\s*=\s*)(['"]?)([^'"\s>]+)\1/g;
    var replaceData = content.replace(reImport, function (match, _, pathKey) {
        if (reIgnorePath.test(pathKey))
            return match;
        var pathSource = path.basename(pathKey);
        return match.replace(pathKey, "".concat(domain, "/file/").concat(pathSource));
    });
    return replaceData;
};
exports.interpolateCssAssets = function (domain, content) {
    var re = /url\((?!['"]?(?:data:|https?:|\/\/))(['"]?)([^'")]*)\1\)/g;
    return content.replace(re, function (match, _, pathKey) {
        var isImg = /\.(jpg|jpeg|png|gif|bmp)$/.test(pathKey);
        var cdnPathKey = isImg ? "image" : "file";
        var pathSource = path.basename(pathKey);
        return match.replace(pathKey, "".concat(domain, "/").concat(cdnPathKey, "/").concat(pathSource));
    });
};
exports.interpolateDomains = function (filesMap, config) {
    var _a;
    var filesMapUrl = Object.values(filesMap) || [];
    if (filesMapUrl.length) {
        var regex = new RegExp("(.*)" + config.folder);
        var result = (_a = filesMapUrl[0].match(regex)) === null || _a === void 0 ? void 0 : _a[0];
        return result;
    }
};
